/* myMusic
 *
 * This program is distributed under the GNU General Public License, version 2.
 * A copy of this license is included with this source.
 *
 * Copyright 2004-2006, Toni Thomsson <toni@tonjac.org> 
*/

/**
	MP3 config info

	Toni Thomsson, toni@tonjac.org
*/

#ifndef mp3_config_h
#define mp3_config_h

#include <zz_string.h>

// The class
class Cmp3Config
{
public:

	//* Construction
	Cmp3Config();
	~Cmp3Config();

	static CzzString getWWWHost( void );
	static CzzString getMailHost( void );
	static CzzString getCGIDir( void );
	static CzzString getLang( void );
	static CzzString getSkin( void );
	static int getAdminUser( const CzzString& usr );
	static CzzString getIPUser( const CzzString& usr );
	static CzzString getRootDir( void );
	static CzzString getDataDir( void );
	static CzzString getM3uDir( void );
	static CzzString getRadioDir( void );
	static CzzString getRealDir( void );
	static CzzString getAutoMail( void );
	static CzzString getIsClosed( void );
	static CzzString getMusicRoot( void );
	static CzzString getLocalRadioUrl( void );
	static CzzString getLocalRadioName( void );
	static CzzString getLicenseNo( void );
	static CzzString getSourceHost( void );
	static CzzString getSourcePort( void );


	static CzzString HEADLINE_ARTIST_INDEX( void );
	static CzzString HEADLINE_ALBUM_INDEX( void );
	static CzzString HEADLINE_PLAYLIST_INDEX( void );
	static CzzString HEADLINE_PLAYLIST_CONTENT( void );
	static CzzString HEADLINE_MYRADIO_INDEX_1( void );
	static CzzString HEADLINE_MYRADIO_INDEX_2( void );
	static CzzString HEADLINE_TEAMS_INDEX_1( void );
	static CzzString HEADLINE_TEAMS_INDEX_2( void );
	static CzzString HEADLINE_SEEK_1( void );
	static CzzString HEADLINE_SEEK_2( void );
	static CzzString HEADLINE_INFO( void );
	static CzzString HEADLINE_PLAYLIST_NOTSAVED( void );
	static CzzString HEADLINE_HELP( void );
	
	static CzzString ALT_PLAY_LIST( void );
	static CzzString ALT_PLAY_ALL_SONGS( void );
	static CzzString ALT_PLAY_ALL_ALBUMS( void );
	static CzzString ALT_PLAY_ALBUMS( void );
	static CzzString ALT_PLAY_CHANNEL( void );

	static CzzString SEEK_RESULT_1( void );
	static CzzString SEEK_RESULT_2( void );

	static CzzString SONGS( void );

	static long getMaxResultSize( void );
		
private:
	static CzzString getEntry( const CzzString& entry );
	static CzzString getEntry( const CzzString& block, const CzzString& entry );
	static void setEntry( const CzzString& entry, const CzzString& value );
};

#endif // mp3_config_h


