/* myMusic
 *
 * This program is distributed under the GNU General Public License, version 2.
 * A copy of this license is included with this source.
 *
 * Copyright 2004-2006, Toni Thomsson <toni@tonjac.org> 
*/

// Implementation of class Cmp3GeneralData

#include "mp3_general_data.h"
#include "mp3_config.h"
#include "mp3_svc.h"

// Construction
Cmp3GeneralData::Cmp3GeneralData( const CzzString& back_url, const CzzString& title, const CzzString& headline )
 : CzzDataService( "getGeneralData" ), m_IP(), m_Title(title), m_Headline(headline), m_BackUrl(back_url)
{

}

// Destruction
Cmp3GeneralData::~Cmp3GeneralData()
{

}

CzzDataServiceReply* Cmp3GeneralData::execute( void* session, CzzParameterMap* req )
{
	CzzDataService::execute( session, req );

	CzzDataServiceReply* reply = new CzzDataServiceReply();


	reply->addField( MP3_FLD_BACK_URL, m_BackUrl );
	reply->addField( MP3_FLD_TITLE, m_Title );
	reply->addField( MP3_FLD_HEADLINE, m_Headline );
	reply->addField( MP3_FLD_IP, getIP() );
	reply->addField( MP3_FLD_USER, getUser() );
	reply->addField( MP3_FLD_SID, (*(CzzString*)(session)) );
	reply->addField( MP3_FLD_VERSION, "version 2.1" );
	reply->addField( MP3_FLD_LANG, Cmp3Config::getLang() );
	reply->addField( MP3_FLD_SKIN, Cmp3Config::getSkin() );
	reply->addField( MP3_FLD_COPYRIGHT, "&copy; Copyright 2004-07, " 
		"<a href='mailto: toni@tonjac.org'>Toni Thomsson</a>, " 
		"<a href='http://www.tonjac.org'>tonjac.org</a>, All rights reserved" );


	reply->addField( "Index0-9", CzzString::Format( "%s/mp3_gui.exe?svc=%d&anchor=%s", 
											Cmp3Config::getCGIDir().c_str(),
											MP3_SVC_LIST_ARTISTS, "0...9" ) );
	reply->addField( "IndexA", CzzString::Format( "%s/mp3_gui.exe?svc=%d&anchor=%s", 
											Cmp3Config::getCGIDir().c_str(),
											MP3_SVC_LIST_ARTISTS, "A" ) );
	reply->addField( "IndexB", CzzString::Format( "%s/mp3_gui.exe?svc=%d&anchor=%s", 
											Cmp3Config::getCGIDir().c_str(),
											MP3_SVC_LIST_ARTISTS, "B" ) );
	reply->addField( "IndexC", CzzString::Format( "%s/mp3_gui.exe?svc=%d&anchor=%s", 
											Cmp3Config::getCGIDir().c_str(),
											MP3_SVC_LIST_ARTISTS, "C" ) );
	reply->addField( "IndexD", CzzString::Format( "%s/mp3_gui.exe?svc=%d&anchor=%s", 
											Cmp3Config::getCGIDir().c_str(),
											MP3_SVC_LIST_ARTISTS, "D" ) );
	reply->addField( "IndexE", CzzString::Format( "%s/mp3_gui.exe?svc=%d&anchor=%s", 
											Cmp3Config::getCGIDir().c_str(),
											MP3_SVC_LIST_ARTISTS, "E" ) );
	reply->addField( "IndexF", CzzString::Format( "%s/mp3_gui.exe?svc=%d&anchor=%s", 
											Cmp3Config::getCGIDir().c_str(),
											MP3_SVC_LIST_ARTISTS, "F" ) );
	reply->addField( "IndexG", CzzString::Format( "%s/mp3_gui.exe?svc=%d&anchor=%s", 
											Cmp3Config::getCGIDir().c_str(),
											MP3_SVC_LIST_ARTISTS, "G" ) );
	reply->addField( "IndexH", CzzString::Format( "%s/mp3_gui.exe?svc=%d&anchor=%s", 
											Cmp3Config::getCGIDir().c_str(),
											MP3_SVC_LIST_ARTISTS, "H" ) );
	reply->addField( "IndexI", CzzString::Format( "%s/mp3_gui.exe?svc=%d&anchor=%s", 
											Cmp3Config::getCGIDir().c_str(),
											MP3_SVC_LIST_ARTISTS, "I" ) );
	reply->addField( "IndexJ", CzzString::Format( "%s/mp3_gui.exe?svc=%d&anchor=%s", 
											Cmp3Config::getCGIDir().c_str(),
											MP3_SVC_LIST_ARTISTS, "J" ) );
	reply->addField( "IndexK", CzzString::Format( "%s/mp3_gui.exe?svc=%d&anchor=%s", 
											Cmp3Config::getCGIDir().c_str(),
											MP3_SVC_LIST_ARTISTS, "K" ) );
	reply->addField( "IndexL", CzzString::Format( "%s/mp3_gui.exe?svc=%d&anchor=%s", 
											Cmp3Config::getCGIDir().c_str(),
											MP3_SVC_LIST_ARTISTS, "L" ) );
	reply->addField( "IndexM", CzzString::Format( "%s/mp3_gui.exe?svc=%d&anchor=%s", 
											Cmp3Config::getCGIDir().c_str(),
											MP3_SVC_LIST_ARTISTS, "M" ) );
	reply->addField( "IndexN", CzzString::Format( "%s/mp3_gui.exe?svc=%d&anchor=%s", 
											Cmp3Config::getCGIDir().c_str(),
											MP3_SVC_LIST_ARTISTS, "N" ) );
	reply->addField( "IndexO", CzzString::Format( "%s/mp3_gui.exe?svc=%d&anchor=%s", 
											Cmp3Config::getCGIDir().c_str(),
											MP3_SVC_LIST_ARTISTS, "O" ) );
	reply->addField( "IndexP", CzzString::Format( "%s/mp3_gui.exe?svc=%d&anchor=%s", 
											Cmp3Config::getCGIDir().c_str(),
											MP3_SVC_LIST_ARTISTS, "P" ) );
	reply->addField( "IndexQ", CzzString::Format( "%s/mp3_gui.exe?svc=%d&anchor=%s", 
											Cmp3Config::getCGIDir().c_str(),
											MP3_SVC_LIST_ARTISTS, "Q" ) );
	reply->addField( "IndexR", CzzString::Format( "%s/mp3_gui.exe?svc=%d&anchor=%s", 
											Cmp3Config::getCGIDir().c_str(),
											MP3_SVC_LIST_ARTISTS, "R" ) );
	reply->addField( "IndexS", CzzString::Format( "%s/mp3_gui.exe?svc=%d&anchor=%s", 
											Cmp3Config::getCGIDir().c_str(),
											MP3_SVC_LIST_ARTISTS, "S" ) );
	reply->addField( "IndexT", CzzString::Format( "%s/mp3_gui.exe?svc=%d&anchor=%s", 
											Cmp3Config::getCGIDir().c_str(),
											MP3_SVC_LIST_ARTISTS, "T" ) );
	reply->addField( "IndexU", CzzString::Format( "%s/mp3_gui.exe?svc=%d&anchor=%s", 
											Cmp3Config::getCGIDir().c_str(),
											MP3_SVC_LIST_ARTISTS, "U" ) );
	reply->addField( "IndexV", CzzString::Format( "%s/mp3_gui.exe?svc=%d&anchor=%s", 
											Cmp3Config::getCGIDir().c_str(),
											MP3_SVC_LIST_ARTISTS, "V" ) );
	reply->addField( "IndexW", CzzString::Format( "%s/mp3_gui.exe?svc=%d&anchor=%s", 
											Cmp3Config::getCGIDir().c_str(),
											MP3_SVC_LIST_ARTISTS, "W" ) );
	reply->addField( "IndexX", CzzString::Format( "%s/mp3_gui.exe?svc=%d&anchor=%s", 
											Cmp3Config::getCGIDir().c_str(),
											MP3_SVC_LIST_ARTISTS, "X" ) );
	reply->addField( "IndexY", CzzString::Format( "%s/mp3_gui.exe?svc=%d&anchor=%s", 
											Cmp3Config::getCGIDir().c_str(),
											MP3_SVC_LIST_ARTISTS, "Y" ) );
	reply->addField( "IndexZ", CzzString::Format( "%s/mp3_gui.exe?svc=%d&anchor=%s", 
											Cmp3Config::getCGIDir().c_str(),
											MP3_SVC_LIST_ARTISTS, "Z" ) );
	reply->addField( "Index_AO", CzzString::Format( "%s/mp3_gui.exe?svc=%d&anchor=%s", 
											Cmp3Config::getCGIDir().c_str(),
											MP3_SVC_LIST_ARTISTS, "" ) );
	reply->addField( "Index_AE", CzzString::Format( "%s/mp3_gui.exe?svc=%d&anchor=%s", 
											Cmp3Config::getCGIDir().c_str(),
											MP3_SVC_LIST_ARTISTS, "" ) );
	reply->addField( "Index_OE", CzzString::Format( "%s/mp3_gui.exe?svc=%d&anchor=%s", 
											Cmp3Config::getCGIDir().c_str(),
											MP3_SVC_LIST_ARTISTS, "" ) );


	reply->addField( MP3_FLD_LIST_PLAYLISTS, CzzString::Format( "%s/mp3_gui.exe?svc=%d", 
											Cmp3Config::getCGIDir().c_str(),
											MP3_SVC_LIST_M3U ) );

	reply->addField( MP3_FLD_LIST_MYRADIO, CzzString::Format( "%s/mp3_gui.exe?svc=%d", 
											Cmp3Config::getCGIDir().c_str(),
											MP3_SVC_LIST_MYRADIO ) );

	reply->addField( MP3_FLD_LIST_CHANNELS, CzzString::Format( "%s/mp3_gui.exe?svc=%d", 
											Cmp3Config::getCGIDir().c_str(),
											MP3_SVC_LIST_RADIO ) );

	reply->addField( MP3_FLD_LIST_LATEST, CzzString::Format( "%s/mp3_gui.exe?svc=%d", 
											Cmp3Config::getCGIDir().c_str(),
											MP3_SVC_LIST_LATEST ) );

	
	reply->addField( MP3_FLD_INFO_LINK, CzzString::Format( "%s/mp3_gui.exe?svc=%d", 
											Cmp3Config::getCGIDir().c_str(),
											MP3_SVC_LIST_INFO ) );

	reply->addField( MP3_FLD_SEEK_LINK, CzzString::Format( "%s/mp3_gui.exe?svc=%d", 
											Cmp3Config::getCGIDir().c_str(),
											MP3_SVC_LIST_SEEK ) );

	reply->addField( MP3_FLD_RAND_LINK, CzzString::Format( "%s/mp3_playlist.exe?svc=%d", 
											Cmp3Config::getCGIDir().c_str(),
											4 ) );

	reply->addField( MP3_FLD_HELP, CzzString::Format( "%s/mp3_gui.exe?svc=%d", 
											Cmp3Config::getCGIDir().c_str(),
											MP3_SVC_HELP ) );

	reply->addField( MP3_FLD_SEEK_SVC, CzzString::Format( "%d", MP3_SVC_LIST_SEEK ) );

	reply->addField( MP3_FLD_SEEK_LINK, CzzString::Format( "%s/mp3_gui.exe", Cmp3Config::getCGIDir().c_str() ) );

	return reply;
}

CzzString Cmp3GeneralData::getIP( void )
{

	if( m_IP.size() <= 0 )
	{
		char* u = getenv( "REMOTE_ADDR" );
	
		if( u != NULL )
			m_IP = u;
		else
			m_IP = "unknown";
	}

	return m_IP;
}

CzzString Cmp3GeneralData::getUser( void )
{

	if( m_User.size() <= 0 )
	{
		char* u = getenv( "REMOTE_USER" );
	
		if( u != NULL )
			m_User = u;
		else
			m_User = "unknown";
	}

	return m_User;
}

int Cmp3GeneralData::size()
{
    return sizeof(Cmp3GeneralData);
}