/* myMusic
 *
 * This program is distributed under the GNU General Public License, version 2.
 * A copy of this license is included with this source.
 *
 * Copyright 2004-2006, Toni Thomsson <toni@tonjac.org> 
*/

#ifndef mp3_track_h
#define mp3_track_h

#include <zz_string.h>
#include <id3/tag.h>

class Cmp3Track
{
public:

    //* Construction
    Cmp3Track( const CzzString& name, const CzzString& album, const char* file );
    virtual ~Cmp3Track();
    
    CzzString getTitle( void );
    CzzString getArtist( void );
    CzzString getAlbum( void );
    CzzString getFile( void );
    int getNumber( void );
    int getTime( void );
    int getBitrate( void );

protected:
private:
    void readID3( const char* file, CzzString& title, CzzString& artist, uint32* time, uint32* no, uint32* speed );

    uint32 m_Number;
    uint32 m_Time;
    uint32 m_BitRate;
    CzzString m_Title;
    CzzString m_Artist;
    CzzString m_Album;
    CzzString m_File;
};

#endif // mp3_track_h