/* myMusic
 *
 * This program is distributed under the GNU General Public License, version 2.
 * A copy of this license is included with this source.
 *
 * Copyright 2004-2006, Toni Thomsson <toni@tonjac.org> 
*/
 
/**
	myMusic Webserver NT-service

	Toni Thomsson, toni@tonjac.org
*/

#ifndef mp3_nt_webservice_h
#define mp3_nt_webservice_h

#include <zz_nt_service.h>
#include <zz_access_log.h>
#include "mp3_http_server.h"
#include "mp3_web_config.h"

#ifdef BUILD_MYMUSIC_DEMO
#define WEB_SVC_NAME "myMusic_WebServer_DEMO"
#else
#define WEB_SVC_NAME "myMusic_WebServer"
#endif

#define WEB_SVC_DESCRIPTION "Mini webserver for myMusic"

class Cmp3NtWebService : public CzzNTService
{
public:

	//* Construction
	Cmp3NtWebService( const CzzString& home );
	virtual ~Cmp3NtWebService();

	// When service starts
	virtual void OnStart( int argc, char** argv );

	static CzzString m_Home;

protected:
private:

	void StartJobs( void );
    void updateRegistry( void );

	Cmp3HttpServer* m_Server;
	CzzAccessLog* m_AccessLog;
	Cmp3WebConfig m_Config;
};

#endif // mp3_nt_webservice_h