/* libzzinet
 *
 * This program is distributed under the GNU General Public License, version 2.
 * A copy of this license is included with this source.
 *
 * Copyright 2000-2006, Toni Thomsson <toni@tonjac.org> 
*/

#ifndef zz_image_color_h
#define zz_image_color_h

#include <zz_export.h>

/*
	Description:
	GIF frg

	Library:
	libgd.a libzzinet.a (HPUX) libgd.lib libzzinet.lib (win32)

	Platform:
    HPUX, win32

	Author:
	Toni Thomsson, toni@tonjac.org
*/
class ZZ_API CzzImageColor
{
public:

	/*
		Description:
		Skapar en frg

		Remarks:
		Defaultkonstruktor = svart frg
	*/
    CzzImageColor( void );

	/*
		Remarks:
		Skapar en frg mha. RGB
	*/
    CzzImageColor( int r, int g, int b );

	/*
		Remarks:
		Kopieringskonstruktor
	*/
    CzzImageColor( const CzzImageColor& obj );
    
	// Description: Tilldelningsoperator
    const CzzImageColor& operator=( const CzzImageColor& obj );

	// Description: Destruktor
    virtual ~CzzImageColor();

	// Description: Andel rd (RGB)
    int getRed( void ) const;

	// Description: Andel grn (RGB)
    int getGreen( void ) const;

	// Description: Andel bl (RGB)
    int getBlue( void ) const;

	// Description: vit frg
    static CzzImageColor white( void );

	// Description: svart frg
    static CzzImageColor black( void );

	// Description: bl frg
    static CzzImageColor blue( void );

	// Description: rd frg
    static CzzImageColor red( void );

	// Description: grn frg
    static CzzImageColor green( void );

	// Description: gul frg	
    static CzzImageColor yellow( void );
    
private:
    int m_R;
    int m_G;
    int m_B;
};

#endif // zz_image_color_h


