/* libzz
 *
 * This program is distributed under the GNU General Public License, version 2.
 * A copy of this license is included with this source.
 *
 * Copyright 2000-2006, Toni Thomsson <toni@tonjac.org> 
*/

#ifndef zz_path_h
#define zz_path_h

#include <zz_string.h>
#include <zz_export.h>

/**
	Path utility class

  	@author Toni Thomsson, toni@tonjac.org	
*/
class ZZ_API CzzPath : public CzzString
{
public:

	/** Path */
	CzzPath();

	/** 
        Path
        @param  p   Path
    */
	CzzPath( string p );

	/** 
        Path
        @param  p   Path
    */
	CzzPath( const char* p );

	/** 
        Path
        @param  p   Path
        @param  n   Size of p
    */
	CzzPath( const char* p, size_type n );
	
	virtual ~CzzPath();

	/**
        Strips of the path and returns the filename only
        @param  path    Path
    */
	static CzzString strip( const CzzString& path );
};

#endif // zz_path_h


