/* libzzwin
 *
 * This program is distributed under the GNU General Public License, version 2.
 * A copy of this license is included with this source.
 *
 * Copyright 2000-2006, Toni Thomsson <toni@tonjac.org> 
*/

#ifndef zz_win_exception_h
#define zz_win_exception_h

#include <zz_string.h>
#include <zz_exception.h>
#include <windows.h>

/**
	Windows error

	@author Toni Thomsson, toni@tonjac.org
*/
class ZZ_API CzzWinException : public CzzException
{
public:

	/* 
		Description: 
		verstter ett windows fel till ett CzzException

		Example:
		if( GetModuleFileName( NULL, buff, 256 ) == 0 )
			throw CzzWinException( _LAF, "Kunde lsa modulnamnet" );

	*/
	CzzWinException( int lineNumber,		// IN, radnummer
						CzzString fileName,	// IN, filnamn
						CzzString reason	// IN, orsak
						);

	virtual ~CzzWinException() {};

protected:

	CzzString GetLastErrorText( void );
};

#endif // zz_win_exception_h

